This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 890872 - Review Request: OpenTK - C# library that wraps OpenGL, OpenCL and OpenAL
Review Request: OpenTK - C# library that wraps OpenGL, OpenCL and OpenAL
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: T.C. Hollingsworth
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 890946
  Show dependency treegraph
 
Reported: 2012-12-30 16:29 EST by Miro Hrončok
Modified: 2013-01-24 17:37 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-24 16:59:53 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
tchollingsworth: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miro Hrončok 2012-12-30 16:29:18 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/opentk.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/opentk-0.0-1.20120523svn3125.fc17.src.rpm

Description:

The Open Toolkit is an advanced, low-level C# library that wraps OpenGL, OpenCL
and OpenAL. It is suitable for games, scientific applications and any other
project that requires 3d graphics, audio or compute functionality.

Fedora Account System Username: churchyard

Note: This is my first try for Mono package an I am not sure if I am doing it right.

http://www.opentk.com/doc/chapter/1/linux says:
"...main OpenTK assembly (OpenTK.dll) and the OpenTK.dll.config file - these are all you need to run OpenTK projects..."

Where should I package the OpenTK.dll.config file?
Comment 1 Miro Hrončok 2012-12-31 04:50:53 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/opentk.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/opentk-0.0-2.20120523svn3125.fc17.src.rpm

- The package now owns /usr/lib/mono/opentk directory
Comment 3 Miro Hrončok 2013-01-06 08:04:59 EST
It works fine without OpenTK.dll.config file.
Comment 5 T.C. Hollingsworth 2013-01-11 18:54:39 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[%] = Suggestion, not blocker
[-] = Not applicable
[?] = Not evaluated

Resolution: NEEDS WORK

Issues:
=======
[!]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 1075200 bytes in 8 files.
See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

[!]: BSD license is indicated in addition to the primary MIT license, but no
     comment is provided indicating what is under this license.

[%]: There is no %check section.  If upstream provides test cases, consider
     adding them.  If tests cannot be run in koji (e.g. since this requires
     graphics), consider documenting that fact in the spec file.
     
===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[-]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)", "BSD (3 clause)", "BSD (3 clause) MIT/X11 (BSD
     like)", "Unknown or generated". 4 files have unknown license. Detailed
     output of licensecheck in
     /home/fedora/patches/890872-OpenTK/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[!]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 1075200 bytes in 8 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[?]: Latest version is packaged.
     Note: svn checkout
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[%]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.

Rpmlint
-------
Checking: OpenTK-0.0-4.20130108svn3126.fc19.src.rpm
          OpenTK-0.0-4.20130108svn3126.fc19.noarch.rpm
OpenTK.src:32: E: hardcoded-library-path in %{buildroot}/usr/lib/mono/gac/
OpenTK.src:33: E: hardcoded-library-path in %{buildroot}/usr/lib
OpenTK.src:34: E: hardcoded-library-path in %{buildroot}/usr/lib
OpenTK.src:35: E: hardcoded-library-path in %{buildroot}/usr/lib
OpenTK.src:39: E: hardcoded-library-path in /usr/lib/mono/gac/%{name}*
OpenTK.src:40: E: hardcoded-library-path in /usr/lib/mono/%{name}
OpenTK.src: W: invalid-url Source0: OpenTK-20130108svn3126.tar.gz
OpenTK.noarch: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 6 errors, 2 warnings.

Rpmlint (installed packages)
----------------------------
# rpmlint OpenTK
OpenTK.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'

All false positives.

Requires
--------
OpenTK-0.0-4.20130108svn3126.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    mono(OpenTK) = 1.1.0.0
    mono(OpenTK.GLControl) = 1.1.0.0
    mono(System) = 2.0.0.0
    mono(System.Drawing) = 2.0.0.0
    mono(System.Windows.Forms) = 2.0.0.0
    mono(System.Xml) = 2.0.0.0
    mono(mscorlib) = 2.0.0.0

Provides
--------
OpenTK-0.0-4.20130108svn3126.fc19.noarch.rpm:
    
    OpenTK = 0.0-4.20130108svn3126.fc19
    mono(OpenTK) = 1.1.0.0
    mono(OpenTK.Compatibility) = 1.1.0.0
    mono(OpenTK.GLControl) = 1.1.0.0

MD5-sum check
-------------
Unable to perform, this package uses an SVN checkout.

Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b890872
Comment 6 Miro Hrončok 2013-01-12 07:10:26 EST
(In reply to comment #5)
Thanks for the review.

> [!]: Large documentation must go in a -doc subpackage.
>      Note: Documentation size is 1075200 bytes in 8 files.
> See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation
Will look at that.

> [!]: BSD license is indicated in addition to the primary MIT license, but no
>      comment is provided indicating what is under this license.
I found that more complicated, so I just dropped this comment:
# See License.txt for more information
Isn't that enough?

> [%]: There is no %check section.  If upstream provides test cases, consider
>      adding them.  If tests cannot be run in koji (e.g. since this requires
>      graphics), consider documenting that fact in the spec file.
I cannot find any test, do you see them? Thanks.
Comment 7 T.C. Hollingsworth 2013-01-12 18:51:04 EST
(In reply to comment #6)
> (In reply to comment #5)
> Thanks for the review.
> 
> > [!]: Large documentation must go in a -doc subpackage.
> >      Note: Documentation size is 1075200 bytes in 8 files.
> > See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation
> Will look at that.

With all due respect to fedora-review, I'm not sure 1MB is excessively large.  However, the package would only be like half a megabyte instead of 1.7MB without it, so maybe it has a point.

Since the Packaging Guidelines don't provide any sort of hard limit on when to subpackage documentation, I don't think I can block the review oh this issue, so I leave this to your discretion.

BTW, don't forget to "%doc Documentation/License.txt" in the main package if you end up subpackaging this.

> > [!]: BSD license is indicated in addition to the primary MIT license, but no
> >      comment is provided indicating what is under this license.
> I found that more complicated, so I just dropped this comment:
> # See License.txt for more information
> Isn't that enough?

That'll work great, thanks.

> > [%]: There is no %check section.  If upstream provides test cases, consider
> >      adding them.  If tests cannot be run in koji (e.g. since this requires
> >      graphics), consider documenting that fact in the spec file.
> I cannot find any test, do you see them? Thanks.
There are some Test directories in the Examples directory, though they're probably not intended for the kind of thing %check is intended for.  I'm fairly certain even if proper test cases did exist, you wouldn't be able to run them in koji.  This was only mentioned just to make sure you dotted your i's and crossed your t's.  ;-)
Comment 8 Miro Hrončok 2013-01-13 11:23:46 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/OpenTK.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/OpenTK-0.0-5.20130108svn3126.fc18.src.rpm

I've created a separated doc subpackage with the PDF manual and examples.

I've left regular docs as License, Changelog, etc. in the %ďoc of the main package.

Test in Examples don't seem to be usable in this case. But thanks, you let me to the examples :D
Comment 9 T.C. Hollingsworth 2013-01-13 17:36:17 EST
Everything look fixed and rpmlint indicates no real issues.

This package is APPROVED.
Comment 10 Miro Hrončok 2013-01-13 17:57:07 EST
Thanks.
Comment 11 Miro Hrončok 2013-01-13 17:59:59 EST
New Package SCM Request
=======================
Package Name: OpenTK
Short Description: C# library that wraps OpenGL, OpenCL and OpenAL
Owners: churchyard
Branches: f17 f18
Comment 12 Jon Ciesla 2013-01-14 07:00:43 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-01-14 12:49:02 EST
OpenTK-0.0-5.20130108svn3126.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/OpenTK-0.0-5.20130108svn3126.fc18
Comment 14 Fedora Update System 2013-01-14 12:50:21 EST
OpenTK-0.0-5.20130108svn3126.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/OpenTK-0.0-5.20130108svn3126.fc17
Comment 15 Fedora Update System 2013-01-16 14:19:35 EST
OpenTK-0.0-5.20130108svn3126.fc18 has been pushed to the Fedora 18 testing repository.
Comment 16 Fedora Update System 2013-01-24 16:59:57 EST
OpenTK-0.0-5.20130108svn3126.fc17 has been pushed to the Fedora 17 stable repository.
Comment 17 Fedora Update System 2013-01-24 17:37:28 EST
OpenTK-0.0-5.20130108svn3126.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.